// Table page
$(document).ready(function() {
  // ------------------------------
  // Settings
  // ------------------------------
//  var AJAX_URL = 'https://localhost:3002';

  var selectAllChk = '#select-all';
  var chk = '.checkbox';
  var counter = '.actions-delete-counter';
  var deleteBtn = '.js-delete-items';
  var exportBtn = '.js-export-items'

  // Action block
  var actionView = '.action-block-view';
  var actionEdit = '.action-block-edit';
  var actionDelete = '.action-block-delete';

  function actionData(element) {
    var id = parseInt($(element).closest('tr').find('.checkbox').prop('id'));
    var type = $(element).data().type;
    var elementDetails = {
      id: id,
      type: type
    };
    return elementDetails;
  }

  function updateCounter() {
    var count = 0;
    var presentSelected = $('.checkbox:checked').length > 0 ? false : true;
    var selectedLength = $('.checkbox').each(function(index, item) {
      $(item).prop('checked') === true
        ? count++
        : ''
    });
    $(counter).text(count);
    $(deleteBtn).prop('disabled', presentSelected);
  }

  function deleteData() {
    var items = {
      id: [],
      type: 'deleteAll'
    };
    var selectedLength = $('.checkbox').each(function(index, item) {
      $(item).prop('checked') === true
        ? items.id.push($(item).prop('id'))
        : ''
    });
    return items;
  }

  function exportData() {
    var items = {
      id: [],
      type: 'exportAll'
    };
    var selectedLength = $('.checkbox').each(function(index, item) {
      $(item).prop('checked') === true
        ? items.id.push($(item).prop('id'))
        : ''
    });
    console.log(items);
    return items;
  }

    function getCookie(cname) {
        var name = cname + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
          var c = ca[i];
          while (c.charAt(0) == ' ') {
            c = c.substring(1);
          }
          if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
          }
        }
        return "";
      }

  function ajaxPost(url, data) {
    $.ajax({
        headers: { 'X-CSRFToken': getCookie('csrftoken') },
        type: "POST", //rest Type
        dataType: 'json', //mispelled
        data: JSON.stringify(data),
        url: url,
        async: true,
        contentType: "application/json; charset=utf-8",
        success: function (msg) {
            console.log(msg);
            window.location.replace(window.location.href);
        }
    })
  }

  updateCounter();
  $(selectAllChk).click(function () {
    $(chk).prop('checked', $(this).prop('checked'));
    updateCounter();
  });

  $(chk).on('click', updateCounter);

  $(deleteBtn).on('click', function(e) {
    e.preventDefault()
    var data = deleteData();
    ajaxPost('/news/', data);
  });

  $(exportBtn).on('click', function(e) {
    e.preventDefault()
    var data = exportData();
    ajaxPost('/news/', data);
  });

//  $(actionView).on('click', function(e) {
//    e.preventDefault();
//    var data = actionData(this);
//    ajaxPost('/news/', data);
//  });
//
//  $(actionEdit).on('click', function(e) {
//    e.preventDefault();
//    var data = actionData(this);
//    ajaxPost('/news/', data);
//  });

  $(actionDelete).on('click', function(e) {
    e.preventDefault();
    var data = actionData(this);
    console.log(data);
    ajaxPost('/news/', data);
  });
});




// Index Page
$(document).ready(function() {
  $('.multiselect').fastselect();
  $('#publish-date').datepicker();
});