from django.db import models
from .wp import WpEsiMedia, WpEsiEntity, WpEsiType, WpEsiRegion

class News(models.Model):

    title = models.CharField(max_length=255)
    url = models.TextField(max_length=2083)
    description = models.TextField()
    media_id = models.IntegerField()
    type_id = models.IntegerField()
    region_id = models.IntegerField()
    post_id = models.BigIntegerField()
    publish_date = models.DateTimeField()
    record_date = models.DateTimeField()

    company_id = models.BigIntegerField()
    is_accepted = models.BooleanField(default=False)

    class Meta:
        db_table = 'wp_esi_news_accept'

    def __str__(self):
        return self.title

    def get_media(self):
        return WpEsiMedia.objects.get(id=self.media_id)

    def get_type(self):
        return WpEsiType.objects.get(id=self.type_id)

    def get_region(self):
        return WpEsiRegion.objects.get(id=self.region_id)

    def get_entity(self):
        return WpEsiEntity.objects.get(id=self.company_id)
